import pygame
import globs
from person import Person
from image import im

class Hero(Person):
	
	def __init__(self,state):
		Person.__init__(self,state,-1,-1)
		self.img = im["hero"]
		self.name = "you"
		self.battery = 50
		self.gems = []
		self.weapon = "a pickaxe"
	
	def tick(self,keys):
		for m in globs.moves:
			if m[0] in keys:
				self.move(m[1])
		if pygame.K_t in keys:
			if self.lightOn:
				self.lightOn = False
			elif self.battery > 0:
				self.lightOn = True
				self.battery -= 1
		if pygame.K_SPACE in keys:
			self.move((0,0))

	def move(self,dir):
		Person.move(self,dir,self.state.map.isFree)
		if self.lightOn:
			self.battery -= 1
			if self.battery <= 0:
				self.state.msg(["Your battery ran out."])
				self.lightOn = False
		self.state.npcTick()
	
	def die(self):
		self.state.msg(["You are dead."],(255,0,0))
		self.img = im["deadHero"]
		self.state.gameover = True
		self.state.map.ignoreLight = True
		self.name = "your corpse"
	