from random import *
import globs
from image import im

class Person:

	def __init__(self,state,x,y):
		self.x = x
		self.y = y
		state.map.cells[x][y].visitor = self
		self.state = state
		self.lightOn = True
		self.name = "unnamed"
		self.dexterity = 5
		self.strength = 2
		self.health = 20
		self.maxHealth = 20
		self.img = im["?"]
	
	def tick(self):
		pass
	
	def move(self,dir,testFunc=None):
		nx,ny = self.x+dir[0],self.y+dir[1]
		if not testFunc:
			testFunc = self.state.map.npcFree
		if not 0 <= self.x+dir[0] < globs.WIDTH:
			return
		if not 0 <= self.y+dir[1] < globs.HEIGHT:
			return
		if testFunc(nx,ny):
			self.state.map.cells[self.x][self.y].visitor = None
			self.x = nx
			self.y = ny
		else:
			self.state.map.cells[nx][ny].bump(self)
		self.state.map.cells[self.x][self.y].visit(self)
	
	def bumpBy(self,other):
		if other != self:
			if (other == self.state.hero or self == self.state.hero) and other.dexterity:
				self.hitBy(other)
	
	def hitBy(self,other):
		if self.dexterity < other.dexterity + randint(-5,5):
			damage = other.strength
			self.state.msg(["%s hit %s."%(other.name.capitalize(),self.name)],globs.combatColor)
			self.hurt(damage)
			if other == self.state.hero and not randint(0,other.dexterity*10):
				other.dexterity += 1
				self.state.msg(["You feel more experienced."])
		else:
			self.state.msg(["%s missed %s."%(other.name.capitalize(),self.name)],globs.combatColor)
	
	def hurt(self,amount):
		self.health -= amount
		if self.health <= 0:
			self.die()
	
	def die(self):
		self.state.msg(["%s dies."%self.name.capitalize()])
		self.state.npcs.remove(self)
		self.state.map.cells[self.x][self.y].visitor = None
	
	def render(self,screen):
		screen.blit(self.img,(self.x*globs.CELLW,self.y*globs.CELLH-4))
