import pygame,os
import globs
from image import im
from sound import sm
from text import tm
from npc import *
from map import Map

class PlayState:
	
	def __init__(self):
		self.level = -8
		self.npcs = []
		self.map = Map(self)
		self.map.buildMap(self.level)
		
		self.gameover = False
		self.victory = False
		self.msgs = []
		self.msgImg = pygame.Surface((600,140))
		
		self.msg(["Welcome to Anathema RL"])
	
	def nextLevel(self):
		self.level += 1
		if self.level == 0:
			self.victory = True
		self.npcs = []
		self.map.buildMap(self.level)
	
	def tick(self,keys):
		if pygame.K_F1 in keys:
			self.msg(["RTFM already."],(0,0,0))
		if pygame.K_ESCAPE in keys:
			from menustate import MenuState
			return MenuState()
		if globs.debugMode and pygame.K_TAB in keys:
			self.map.ignoreLight = not self.map.ignoreLight
			
		if self.victory:
			from menustate import VictoryState
			return VictoryState(self.hero.gems)
		if not self.gameover:
			self.hero.tick(keys)	
		return self
	
	def msg(self,msg,color=(255,255,255)):
		msg.reverse()
		self.msgs.extend([(m,color) for m in msg])
		self.msgImg.fill(0x005060)
		l = self.msgs[-7:]
		l.reverse()
		for y,m in enumerate(l):
			self.msgImg.blit(tm.get(m[0],m[1]),(4,y*18))
	
	def die(self):
		self.gameover = True
		self.map.ignoreLight = True
	
	def npcTick(self):
		for npc in self.npcs:
			npc.tick()
	
	def display(self,screen):
		screen.blit(im["HUD.png"],(0,0))
		dudes = []
		if self.hero.lightOn:
			dudes.append(self.hero)
		for npc in self.npcs:
			if npc.lightOn:
				dudes.append(npc)
		self.map.doLight([(d.x,d.y) for d in dudes])
		self.map.render(screen)
		self.hero.render(screen)
		for n in self.npcs:
			if self.map.cells[n.x][n.y].lit:
				n.render(screen)
		#HUD
		screen.blit(self.msgImg,(5,455))
		screen.blit(tm.get(" %i"%self.hero.battery),(620,475))
		screen.blit(tm.get(" %i/%i"%(self.hero.health,self.hero.maxHealth)),(620,492))
		screen.blit(tm.get(" %i"%len(self.hero.gems)),(620,509))
		screen.blit(tm.get("%i"%self.level),(620,526))
		screen.blit(tm.get(" %s"%self.hero.weapon),(620,543))
		screen.blit(tm.get("Dex: %s"%self.hero.dexterity),(610,560))